#!/usr/bin/perl -w

###################################################################
# NOD32 version 3 update mirror creator with auto keys searching  #								  #
# Created by Cmyker aka Igorek Vokar. 				  #
# Send bug reports and thanks to cmyk777@gmail.com		  #
# Greets to my girlfriend Alenka and VITYAN666			  #
###################################################################

use FindBin;
use lib $FindBin::Bin;
use lib $FindBin::Bin . "/lib";
use LWP::UserAgent;
use Data::Dumper;
use File::Path;
use Time::localtime;
use lib::keys;
use strict;


our $bases_path = "/home/www/sitename/nod32"; #Path for downloaded bases
our $nolog = 0; #Write log? 0 - yes, 1 - no

our $upd_file = "update.ver";
our $path = $FindBin::Bin;
our ($username, $password);

start();
sub start {
    my $status = shift(@_);
    my $result = 1;
    open(AUTHFILE, "$path/lib/nod32.auth") or $result = 0;
    if (!$result) {logging("Can't open authfile nod32.auth"); keys::start(); start(); return;}
    $username = <AUTHFILE>;
    $username =~ s/username=//;
    chomp $username;
    $password = <AUTHFILE>;
    $password =~ s/password=//;
    chomp $password;
    if (!$status) {init()};
}

sub init {
    my $downl_result = 1;
    if (-e "$path/$upd_file") { 
	my (@hosts, %updver, %updver_old);
    	my ($hosts_ref, $updver_ref_old) = read_updatever("$upd_file"); @hosts = @$hosts_ref;
	for (my $i = 0; $i <= $#hosts; $i++) {
    	    if ($downl_result) {
		logging("Checking $hosts[$i]");
		rename("$path/$upd_file", "$path/$upd_file.old") || die "Can't rename $upd_file: $!";
		my ($hosts_ref, $updver_ref_old) = read_updatever("$upd_file.old"); %updver_old = %$updver_ref_old;
	    }
    	    my $server = $hosts[$i];
	    $downl_result = downl_file("/update.ver", $server, $path);
	    if (!$downl_result) {next};
	    my ($hosts_new_ref, $updver_ref) = read_updatever("$upd_file"); %updver = %$updver_ref;
	    check_files_ver(\%updver_old, \%updver, $server);
	}
    } else {
	my $server = "http://update.eset.com/eset_upd/";
	downl_file("/update.ver", $server, $path);
	if (!(-d "$bases_path/download/engine3")) { 
	    mkpath("$bases_path/download/engine3", 0, 0777) || die "Can't create dir $bases_path/download/engine3: $!\n";
	    mkpath("$bases_path/download/engine3ess", 0, 0777) || die "Can't create dir $bases_path/download/engine3ess: $!\n";	    
	    mkpath("$bases_path/eset_upd", 0, 0777) || die "Can't create dir $bases_path/download/eset_upd: $!\n";	    
	    my ($hosts_new_ref, $updver_ref) = read_updatever("$upd_file"); my %updver = %$updver_ref;
	    my $server = "http://update.eset.com/";
	    for my $filename ( keys %updver ) {
		$downl_result = downl_file($updver{$filename}{file}, $server, $bases_path);	
	    }
	}
	read_updatever("$upd_file");
	init();
    }
}

sub check_files_ver {
    my %updver_old = %{shift(@_)};
    my %updver = %{shift(@_)};
    my $server = shift(@_);
    $server =~ s/\/eset_upd\///;
    my $updver_flag;
    for my $filename ( keys %updver ) {
	if (!defined($updver_old{$filename}{file}) or !defined($updver{$filename}{file})) {
	    next;
	}
	my $localfilesize = (-s $bases_path.$updver{$filename}{file});
	my $serverfilesize = $updver{$filename}{size};
	if (($updver{$filename}{version}) > ($updver_old{$filename}{version}) 
	or !(-e $bases_path.$updver{$filename}{file}) or ($localfilesize != $serverfilesize
	&& $updver{$filename}{version} > $updver_old{$filename}{version})) {
	    $updver_flag = 1;
	    logging("Downloading $updver{$filename}{file}($updver{$filename}{version}) old version ($updver_old{$filename}{version}) from $server");
	    downl_file($updver{$filename}{file}, $server, $bases_path);
	}
    }
    if ($updver_flag) {
	downl_file("/update.ver", $server."/eset_upd/", $bases_path."/eset_upd");
    } else {
	logging("Local bases copy is up to date");
    }
}

sub downl_file {
    my $file = shift(@_);    
    my $server = shift(@_);
    $server =~ s/\/$//;
    my $path = shift(@_);
    my $ua = LWP::UserAgent->new;
    $ua->timeout(10);
    my $req = HTTP::Request->new(GET => $server.$file);
    $req->authorization_basic($username, $password);
    my $res=$ua->request($req);
    open(F, ">$path/$file");  
    binmode F;
    print F $res->decoded_content;
    close F;
    my $status=$res->status_line;
    if ($status =~ /401/) {logging("Auth to $server failed searching for new key"); keys::start(); start("1"); return 0;}
    if ($status =~ /500 read/) {logging("Connection timeout to $server while checking $file");return 0;}
    if ($status =~ /500 Cannot/) {logging("Error writing $file: $!");return 0;}
    if ($file =~ /update/ && $path ne $bases_path."/eset_upd") {system("$path/lib/unrar e -y $path/update.ver $path 2>/dev/null > /dev/null")};
}

sub read_updatever {
    my $updver = shift(@_);
    my ($file, @hosts, %updver);
    open(UPDATE, "$path/$updver") || die "couldn't open the $updver!\n";
    while (<UPDATE>) {
	$file = $file . $_;
    }
    my @files = split(/\[/, $file);
    for (my $i = 0; $i <= $#files ;$i++) {
	$_ = $files[$i];
	if (/^HOSTS\].+\n(Other=.+?)\n.+/s) { @hosts = get_hosts($1) };
	if (/^(.+)\].+versionid=(\d+).+file=(.+\.nup).+size=(\d+).+/s) {
	    $updver{$1}{'version'} = $2;
	    $updver{$1}{'file'} = $3;
	    $updver{$1}{'size'} = $4;	    
	}
    }
    return (\@hosts, \%updver);
}

sub get_hosts {
    $_ = shift(@_);
    chop;    
    s/Other=\d0*@//;
    my @hosts = split(/, \d0*@/);
    return @hosts;
}

sub logging {
    if ($nolog) {return};
    open (LOGFILE, ">>$path/nod32.log");
    my $datetime = localtime (time);
    my $log = sprintf("%02d-%02d-%02d", $datetime->mday(), ($datetime->mon()+1), ($datetime->year()+1900)) 
    . sprintf(" %02d:%02d:%02d", $datetime->hour(), $datetime->min(), $datetime->sec()) . " " . $_[0] . "\n";
    print LOGFILE $log;
}
close LOGFILE;
unlink(<$path/update.ver.old>);